3 # Copyright (c) 2005 Junio C Hamano
8 git-merge [options] <remote>...
9 git-merge [options] <msg> HEAD <remote>
11 summary show a diffstat at the end of the merge
12 n,no-summary don't show a diffstat at the end of the merge
13 squash create a single commit instead of doing a merge
14 commit perform a commit if the merge sucesses (default)
15 ff allow fast forward (default)
16 s,strategy= merge strategy to use
17 m,message= message to be used for the merge commit (if any)
25 test -z "$(git ls-files -u)" ||
26 die "You are in the middle of a conflicted merge."
31 all_strategies='recur recursive octopus resolve stupid ours subtree'
32 default_twohead_strategies='recursive'
33 default_octopus_strategies='octopus'
34 no_fast_forward_strategies='subtree ours'
35 no_trivial_strategies='recursive recur subtree ours'
43 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
44 "$GIT_DIR/MERGE_STASH" || exit 1
48 # Stash away any local modifications.
49 git stash create >"$GIT_DIR/MERGE_STASH"
53 if test -f "$GIT_DIR/MERGE_STASH"
55 git reset --hard $head >/dev/null
56 git stash apply $(cat "$GIT_DIR/MERGE_STASH")
57 git update-index --refresh >/dev/null
61 finish_up_to_date () {
64 echo "$1 (nothing to squash)" ;;
72 echo Squashed commit of the following:
74 git log --no-merges ^"$head" $remoteheads
80 rlogm="$GIT_REFLOG_ACTION"
83 rlogm="$GIT_REFLOG_ACTION: $2"
87 echo "Squash commit -- not updating HEAD"
88 squash_message >"$GIT_DIR/SQUASH_MSG"
93 echo "No merge message -- not updating HEAD"
96 git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
106 if test "$show_diffstat" = t
108 # We want color (if set), but no pager
109 GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
114 # Run a post-merge hook
115 if test -x "$GIT_DIR"/hooks/post-merge
119 "$GIT_DIR"/hooks/post-merge 1
122 "$GIT_DIR"/hooks/post-merge 0
130 rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
131 bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
132 if test "$rh" = "$bh"
134 echo "$rh branch '$remote' of ."
135 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
136 git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
138 echo "$rh branch '$truname' (early part) of ."
139 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
141 sed -e 's/ not-for-merge / /' -e 1q \
142 "$GIT_DIR/FETCH_HEAD"
144 echo "$rh commit '$remote'"
149 while test $# != 0; do
152 show_diffstat=false ;;
156 test "$allow_fast_forward" = t ||
157 die "You cannot combine --squash with --no-ff."
158 squash=t no_commit=t ;;
160 squash= no_commit= ;;
166 allow_fast_forward=t ;;
168 test "$squash" != t ||
169 die "You cannot combine --squash with --no-ff."
170 allow_fast_forward=f ;;
173 case " $all_strategies " in
175 use_strategies="$use_strategies$1 " ;;
177 die "available strategies are: $all_strategies" ;;
195 test $# != 0 || usage
199 if branch=$(git-symbolic-ref -q HEAD)
201 mergeopts=$(git config "branch.${branch#refs/heads/}.mergeoptions")
202 if test -n "$mergeopts"
204 parse_config $mergeopts --
209 while test $args_left -lt $#; do shift; done
211 if test -z "$show_diffstat"; then
212 test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
213 test -z "$show_diffstat" && show_diffstat=t
216 # This could be traditional "merge <msg> HEAD <commit>..." and the
217 # way we can tell it is to see if the second token is HEAD, but some
218 # people might have misused the interface and used a committish that
219 # is the same as HEAD there instead. Traditional format never would
220 # have "-m" so it is an additional safety measure to check for it.
222 if test -z "$have_message" &&
223 second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
224 head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
225 test "$second_token" = "$head_commit"
231 elif ! git rev-parse --verify HEAD >/dev/null 2>&1
233 # If the merged head is a valid one there is no reason to
234 # forbid "git merge" into a branch yet to be born. We do
235 # the same for "git pull".
238 echo >&2 "Can merge only exactly one commit into empty head"
242 rh=$(git rev-parse --verify "$1^0") ||
243 die "$1 - not something we can merge"
245 git update-ref -m "initial pull" HEAD "$rh" "" &&
246 git read-tree --reset -u HEAD
250 # We are invoked directly as the first-class UI.
253 # All the rest are the commits being merged; prepare
254 # the standard merge summary message to be appended to
255 # the given message. If remote is invalid we will die
256 # later in the common codepath so we discard the error
258 merge_name=$(for remote
261 done | git fmt-merge-msg
263 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
265 head=$(git rev-parse --verify "$head_arg"^0) || usage
267 # All the rest are remote heads
268 test "$#" = 0 && usage ;# we need at least one remote head.
269 set_reflog_action "merge $*"
274 remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
275 die "$remote - not something we can merge"
276 remoteheads="${remoteheads}$remotehead "
277 eval GITHEAD_$remotehead='"$remote"'
278 export GITHEAD_$remotehead
280 set x $remoteheads ; shift
282 case "$use_strategies" in
286 var="`git config --get pull.twohead`"
289 use_strategies="$var"
291 use_strategies="$default_twohead_strategies"
294 var="`git config --get pull.octopus`"
297 use_strategies="$var"
299 use_strategies="$default_octopus_strategies"
305 for s in $use_strategies
307 for ss in $no_fast_forward_strategies
316 for ss in $no_trivial_strategies
320 allow_trivial_merge=f
329 common=$(git merge-base --all $head "$@")
332 common=$(git show-branch --merge-base $head "$@")
335 echo "$head" >"$GIT_DIR/ORIG_HEAD"
337 case "$allow_fast_forward,$#,$common,$no_commit" in
339 # No common ancestors found. We need a real merge.
342 # If head can reach all the merge then we are up to date.
343 # but first the most common case of merging one remote.
344 finish_up_to_date "Already up-to-date."
348 # Again the most common case of merging one remote.
349 echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
350 git update-index --refresh 2>/dev/null
352 if test -n "$have_message"
354 msg="$msg (no commit created; -m option ignored)"
356 new_head=$(git rev-parse --verify "$1^0") &&
357 git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
358 finish "$new_head" "$msg" || exit
363 # We are not doing octopus and not fast forward. Need a
367 # We are not doing octopus, not fast forward, and have only
369 git update-index --refresh 2>/dev/null
370 case "$allow_trivial_merge" in
372 # See if it is really trivial.
373 git var GIT_COMMITTER_IDENT >/dev/null || exit
374 echo "Trying really trivial in-index merge..."
375 if git read-tree --trivial -m -u -v $common $head "$1" &&
376 result_tree=$(git write-tree)
380 printf '%s\n' "$merge_msg" |
381 git commit-tree $result_tree -p HEAD -p "$1"
383 finish "$result_commit" "In-index merge"
391 # An octopus. If we can reach all the remote we are up to date.
395 common_one=$(git merge-base --all $head $remote)
396 if test "$common_one" != "$remote"
402 if test "$up_to_date" = t
404 finish_up_to_date "Already up-to-date. Yeeah!"
410 # We are going to make a new commit.
411 git var GIT_COMMITTER_IDENT >/dev/null || exit
413 # At this point, we need a real merge. No matter what strategy
414 # we use, it would operate on the index, possibly affecting the
415 # working tree, and when resolved cleanly, have the desired tree
416 # in the index -- this means that the index must be in sync with
417 # the $head commit. The strategies are responsible to ensure this.
419 case "$use_strategies" in
421 # Stash away the local changes so that we can try more than one.
426 rm -f "$GIT_DIR/MERGE_STASH"
431 result_tree= best_cnt=-1 best_strategy= wt_strategy=
433 for strategy in $use_strategies
435 test "$wt_strategy" = '' || {
436 echo "Rewinding the tree to pristine..."
439 case "$single_strategy" in
441 echo "Trying merge strategy $strategy..."
445 # Remember which strategy left the state in the working tree
446 wt_strategy=$strategy
448 git-merge-$strategy $common -- "$head_arg" "$@"
450 if test "$no_commit" = t && test "$exit" = 0
453 exit=1 ;# pretend it left conflicts.
456 test "$exit" = 0 || {
458 # The backend exits with 1 when conflicts are left to be resolved,
459 # with 2 when it does not handle the given merge at all.
461 if test "$exit" -eq 1
464 git diff-files --name-only
465 git ls-files --unmerged
467 if test $best_cnt -le 0 -o $cnt -le $best_cnt
469 best_strategy=$strategy
476 # Automerge succeeded.
477 result_tree=$(git write-tree) && break
480 # If we have a resulting tree, that means the strategy module
481 # auto resolved the merge cleanly.
482 if test '' != "$result_tree"
484 if test "$allow_fast_forward" = "t"
486 parents=$(git show-branch --independent "$head" "$@")
488 parents=$(git rev-parse "$head" "$@")
490 parents=$(echo "$parents" | sed -e 's/^/-p /')
491 result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
492 finish "$result_commit" "Merge made by $wt_strategy."
497 # Pick the result from the best strategy and have the user fix it up.
498 case "$best_strategy" in
501 case "$use_strategies" in
503 echo >&2 "No merge strategy handled the merge."
506 echo >&2 "Merge with strategy $use_strategies failed."
512 # We already have its result in the working tree.
515 echo "Rewinding the tree to pristine..."
517 echo "Using the $best_strategy to prepare resolving by hand."
518 git-merge-$best_strategy $common -- "$head_arg" "$@"
522 if test "$squash" = t
529 done >"$GIT_DIR/MERGE_HEAD"
530 printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
533 if test "$merge_was_ok" = t
536 "Automatic merge went well; stopped before committing as requested"
543 git ls-files --unmerged |
544 sed -e 's/^[^ ]* / /' |
546 } >>"$GIT_DIR/MERGE_MSG"
548 die "Automatic merge failed; fix conflicts and then commit the result."